/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package exo2;

import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;
import static org.junit.jupiter.api.Assertions.*;

/**
 *
 * @author aponte
 */
public class Question1_solutionTest {
    
    public Question1_solutionTest() {
    }
    
    @BeforeAll
    public static void setUpClass() {
    }
    
    @AfterAll
    public static void tearDownClass() {
    }
    
    @BeforeEach
    public void setUp() {
    }
    
    @AfterEach
    public void tearDown() {
    }

    /**
     * Test of estPalindrome method, nul pointer.
     */
    @Test
    public void testEstPalindromeNull() {
        String m = null;
        assertThrows(NullPointerException.class,()->Question1_solution.estPalindrome(m));
    }
    /**
     * Test of estPalindrome method, chaîne vide.
     */
    @Test
    public void testEstPalindromeVide() {
        String m = "";
        assertTrue(Question1_solution.estPalindrome(m));
    }
    
    /**
     * Test of estPalindrome method, chaîne taille 1
     * (la plus petite taille non vide).
     */
    @Test
    public void testEstPalindromeTailleUn() {
        String m = "a";
        assertTrue(Question1_solution.estPalindrome(m));
    }
    
    /**
     * Test of estPalindrome method, chaîne taille 2 
     * (la plus petite taille pair), donne vrai
     */
    @Test
    public void testEstPalindrometailleDeuxOK() {
        String m = "bb";
        assertTrue(Question1_solution.estPalindrome(m));
    }
    /**
     * Test of estPalindrome method, chaîne taille 2 
     * (la plus petite taille pair), donne vrai
     */
    @Test
    public void testEstPalindrometailleDeuxNot() {
        String m = "ba";
        assertFalse(Question1_solution.estPalindrome(m));
    }
    /**
     * Test of estPalindrome method, chaîne taille 3 (ok).
     */
    @Test
    public void testEstPalindromeTailleTroisOK() {
        String m = "aba";
        assertTrue(Question1_solution.estPalindrome(m));
    }
    
    /**
     * Test of estPalindrome method, chaîne taille 3 (ok).
     */
    @Test
    public void testEstPalindromeTailleTroisNot() {
        String m = "abc";
        assertFalse(Question1_solution.estPalindrome(m));
    }
    /**
     * Test of estPalindrome method, chaîne taille pair > 2, donne vrai.
     */
    @Test
    public void testEstPalindromePlus2OK() {
        String m = "eluparcettecrapule";
        assertTrue(Question1_solution.estPalindrome(m));
    }
    
    /**
     * Test of estPalindrome method, chaîne taille pair > 2, donne faux.
     */
    @Test
    public void testEstPalindromePlus2Not() {
        String m = "abca";
        assertFalse(Question1_solution.estPalindrome(m));
    }
    
    /**
     * Test of estPalindrome method, chaîne taille impair > 3, donne vrai.
     */
    @Test
    public void testEstPalindromePlus3OK() {
        String m = "laval";
        assertTrue(Question1_solution.estPalindrome(m));
    }
    
    /**
     * Test of estPalindrome method, chaîne taille impair > 3, donne faux.
     */
    @Test
    public void testEstPalindromePlus3Not() {
        String m = "abcbk";
        assertFalse(Question1_solution.estPalindrome(m));
    }
    
}
